﻿import os
from glob import glob
import IPython
import shutil


SEARCHPATH="./"
top_files = ["top.tex"]
extensions = ['jpg','off','obj','png','log','loglog','pdf','dpth','dep','bat','fig','m','pdn','motion','tex','xlsx','csv','ai','svg']
folder_list = [x for x in os.walk(SEARCHPATH)] #  if x.split('.')[-1] in extensions

# remove .svn folders
for root, subFolders, files in os.walk(SEARCHPATH):
    if '.svn' in subFolders:
        shutil.rmtree(os.path.join(root,'.svn'))
        
# get all relevan files
file_list = []
for folder in folder_list:
	path = folder[0]
	for file in folder[2]:
		if file.split('.')[-1] in extensions:
			file_list.append(os.path.join(path,file))

# read and preprocess log files 
log_file_stack = ""
for file in file_list:
	if file.split('.')[-1] == 'log' or file.split('/')[-1] in top_files:
		print("Replacing newlines in {} ({})".format(file,file.split('/')[-1]))
		with open(file, "r") as f:
			log = f.read() # read everything in the file
			log.replace('\n\r','')
			log.replace('\n','')
			log_file_stack += log
			
# search for unreferenced files
for file in file_list:
	file_path_non_relative = file[2:]
	if log_file_stack.find(file_path_non_relative)<0:
		print("No reference for {}, deleting".format(file))
		os.remove(file)

for file in file_list:
	file_path_non_relative = file[2:]
	if log_file_stack.find(file_path_non_relative)>=0:
		print("Reference for {}".format(file))

# remove empty folders
def removeEmptyFolders(path, removeRoot=True):
  'Function to remove empty folders'
  if not os.path.isdir(path):
    print('{} is not a dir'.format(path))
    return

  # remove empty subfolders
  files = os.listdir(path)
  if len(files):
    for f in files:
      fullpath = os.path.join(path, f)
      print('fullpath',fullpath)
      if os.path.isdir(fullpath):
        removeEmptyFolders(fullpath)

  # if folder empty, delete it
  files = os.listdir(path)
  if len(files) == 0 and removeRoot:
    print("Removing empty folder:", path)
    os.rmdir(path)
    
removeEmptyFolders('./',removeRoot=False)

